import java.security.KeyStore;
import java.util.*;

public class MyMap<K, V> implements Map<K, V> {

    private MySet<MyEntry<K,V>> entries = new MySet<MyEntry<K,V>>();

    @Override
    public void clear() {
        entries = new MySet<MyEntry<K,V>>();
    }
    @Override
    public boolean containsKey(Object key) {
        for (MyEntry entry : entries) {
            if (entry.getKey().equals(key)) return true;
        }
        return false;
    }
    @Override
    public boolean containsValue(Object value) {
        for (MyEntry entry : entries) {
            if (entry.getValue().equals(value)) return true;
        }
        return false;
    }
    @Override
    public Set<Entry<K,V>> entrySet() {
        Set<Entry<K,V>> returnSet = new MySet<>();

        for (Entry entry: entries) {
            returnSet.add(entry);
        }
        return null;
    }
    @Override
    public V get(Object key) {
        for (Entry entry: entries) {
            if (entry.getKey().equals(key)) return (V) entry.getValue();
        }
        return null;
    }

    @Override
    public boolean isEmpty() {
        return size() == 0;
    }
    @Override
    public Set<K> keySet() {
        Set<K> returnSet = new MySet<K>();
        for (Entry entry: entries) {
            returnSet.add((K) entry.getKey());
        }
        return returnSet;
    }
    @Override
    public V put(K key, V value) {
        if (!containsKey(key)) {
            entries.add(new MyEntry<K, V>(key, value));
            return value;
        }
        return null;
    }
    @Override
    public void putAll(Map<? extends  K, ? extends  V> m) {
        Set<? extends K> keySet = m.keySet();
        for (K k : keySet) {
            put(k, m.get(k));
        }
    }
    @Override
    public V remove(Object key) {
        for (Entry entry : entries) {
            if (entry.getKey().equals(key)) {
                entries.remove(entry);
                return (V) entry.getValue();
            }
        }
        return null;
    }
    @Override
    public int size() {
        return entries.size();
    }
    @Override
    public Collection<V> values() {
        Collection<V> collection = new ArrayList<V>();
        for (Entry entry : entries) {
            collection.add( (V) entry.getValue());
        }
        return collection;
    }

    private class MyEntry<K, V> implements Entry<K, V>{

        private K key;
        private V value;

        public MyEntry(K key, V value) {
            this.key = key;
            this.value = value;
        }

        public K getKey() {
            return key;
        }
        public V getValue() {
            return value;
        }
        public V setValue(V value) {
            this.value = value;
            return value;
        }
        public boolean equals(Object o) {
            return this == o;
        }
        public int hashCode() {
            return Objects.hash(key, value);
        }
    }

}
