import org.junit.Assert;
import org.junit.Test;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;

import static org.junit.Assert.*;

public class MyArrayListTest {


        @Test
        public void addTest() {
            MyArrayList<Integer> ints = new MyArrayList<>();
            ints.add(2);
            Integer expected = 2;
            Integer actual = ints.get(0);
            Assert.assertEquals(expected, actual);
        }

        @Test
        public void addTestWhenMaxCapacityReached() {
            MyArrayList<Integer> ints = new MyArrayList<>();
            ints.add(0);
            ints.add(1);
            ints.add(2);
            ints.add(3);
            ints.add(4);
            ints.add(5);
            ints.add(6);
            ints.add(7);
            ints.add(8);
            ints.add(9);
            ints.add(10);
            ints.add(11);

            Integer expected = 11;
            Integer actual = ints.get(11);

            Assert.assertEquals(expected, actual);
        }

        @Test
        public void toArrayTest() {
            MyArrayList<Integer> ints = new MyArrayList<>();
            ints.add(0);
            ints.add(1);
            ints.add(2);
            ints.add(3);

            Object[] expected = {0, 1, 2, 3};
            Object[] actual = ints.toArray();

            Assert.assertTrue(Arrays.deepEquals(expected, actual));
        }

        @Test
        public void toArrayTest2() {
            MyArrayList<Integer> ints = new MyArrayList<>();
            ints.add(0);
            ints.add(1);
            ints.add(2);
            ints.add(3);

            Integer[] expected = {0, 1, 2, 3};
            Integer[] actual = new Integer[expected.length];
            actual = ints.toArray(actual);

            Assert.assertTrue(Arrays.deepEquals(expected, actual));
        }

        @Test
        public void clearTest() {
            MyArrayList<Integer> ints = new MyArrayList<>();
            ints.add(0);
            ints.add(1);
            ints.add(2);
            ints.add(3);

            ints.clear();

            Object[] expected = {};
            Object[] actual = ints.toArray();

            Assert.assertTrue(Arrays.deepEquals(actual, expected));
        }

        @Test
        public void removeTest() {
            MyArrayList<Integer> ints = new MyArrayList<>();
            ints.add(0);
            ints.add(1);
            ints.add(2);
            ints.add(3);

            ints.remove(2);

            Object[] expected = {0, 1, 3};
            Object[] actual = ints.toArray();

            Assert.assertTrue(Arrays.deepEquals(actual, expected));
        }
        @Test
        public void isEmptyTest() {
            MyArrayList<Integer> ints = new MyArrayList<>();

            boolean expected = true;
            boolean actual = ints.isEmpty();

            Assert.assertEquals(expected, actual);
        }

        @Test
        public void indexOfTest() {
            MyArrayList<Integer> ints = new MyArrayList<>();
            ints.add(1);
            ints.add(2);
            ints.add(3);
            ints.add(4);

            int expected = 1;
            int actual = ints.indexOf(2);

            Assert.assertEquals(expected, actual);
        }

        @Test
        public void indexOfTestWhenElementDoesNotExist() {
            MyArrayList<Integer> ints = new MyArrayList<>();
            ints.add(1);
            ints.add(2);
            ints.add(3);
            ints.add(4);

            int expected = -1;
            int actual = ints.indexOf(9);

            Assert.assertEquals(expected, actual);
        }

        @Test
        public void containsTest() {
            MyArrayList<Integer> ints = new MyArrayList<>();
            ints.add(1);
            ints.add(2);
            ints.add(3);
            ints.add(4);

            boolean expected = true;
            boolean actual = ints.contains(3);

            Assert.assertEquals(expected, actual);
        }

        @Test
        public void containsTestWhenValueIsNotPresent() {
            MyArrayList<Integer> ints = new MyArrayList<>();
            ints.add(1);
            ints.add(2);
            ints.add(3);
            ints.add(4);

            boolean expected = false;
            boolean actual = ints.contains(9);

            Assert.assertEquals(expected, actual);

        }

        @Test
        public void addTestWithIndex() {
            MyArrayList<Integer> ints = new MyArrayList<>();
            ints.add(1);
            ints.add(2);
            ints.add(3);

            ints.add(15, 1);

            Object[] expected = {1, 15, 2, 3};
            Object[] actual = ints.toArray();

            Assert.assertTrue(Arrays.deepEquals(expected, actual));

        }

        @Test
        public void testAddAll() {
            MyArrayList<Integer> ints = new MyArrayList<>();
            ints.add(1);
            ints.add(2);
            ints.add(3);

            Collection<Integer> c = new ArrayList<Integer>();
            c.add(4);
            c.add(5);
            c.add(6);

            ints.addAll(c);

            Object[] expected = {1,2,3,4,5,6};
            Object[] actual = ints.toArray();

            Assert.assertTrue(Arrays.deepEquals(expected, actual));
        }
    }
